﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Olap;
using Infragistics.Olap.FlatData;
using Infragistics.Controls.Grids;


namespace PivotGridTest
{
    public class PctTotalAggregator : Aggregator<decimal>
    {
        private FlatDataSource _flatDataSource;
        private IAggregateable _baseMeasure;
        private string BaseMeasureName;

        public PctTotalAggregator(FlatDataSource flatDataSource, string baseMeasureName)
        {
            this.BaseMeasureName = baseMeasureName;
            this._flatDataSource = flatDataSource;
            this._flatDataSource.Initialized += this.DataSource_Initialized;
        }

        private void DataSource_Initialized(object sender, EventArgs e)
        {
            // get other aggregateables you are interested in
            this._baseMeasure = (IAggregateable)this._flatDataSource.Cube.Measures[BaseMeasureName];
        }

        public override IAggregationResult<decimal, decimal> Evaluate(IAggregationResult<decimal, decimal> oldResult, decimal value)
        {
            throw new NotImplementedException();
        }

        public override IAggregationResult<decimal, decimal> Evaluate(IAggregationResult<decimal, decimal> oldResult, IAggregateable aggregateable, System.Collections.IEnumerable items)
        {
            double change = 0;
            double basis = 0;

            foreach (var item in items)
            {
                change += (double)aggregateable.GetValue(item); // error here: specified cast is not valid
                basis = (double)this._baseMeasure.GetValue(item);
            }

            decimal result = basis == 0 ? 0m : new decimal(change / basis);
            return new SingleResult<decimal>(result);
        }
    }
}
